"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitExit = exports.filterAsync = exports.chainAsync = exports.mapAsync = exports.thenAll = exports.then = exports.flattenSchema = exports.protoTsTypesMapping = void 0;
var R = __importStar(require("ramda"));
// Mapping protobuf (simple) types to TypeScript types
exports.protoTsTypesMapping = [
    { proto: 'bool', ts: 'boolean' },
    { proto: 'string', ts: 'string' },
    { proto: 'int32', ts: 'number' },
    { proto: 'uint32', ts: 'number' },
    { proto: 'sint32', ts: 'number' },
    { proto: 'int64', ts: 'number' },
    { proto: 'uint64', ts: 'number' },
    { proto: 'sint64', ts: 'number' },
    { proto: 'float', ts: 'number' },
    { proto: 'double', ts: 'number' },
    { proto: 'bytes', ts: 'Uint8Array' },
];
var ignoredNamespaces = [
    ['scalapb'],
    ['google', 'protobuf'],
    ["coop", "rchain", "comm", "protocol", "routing"],
    ["routing"], // v0.9.14
];
// Transform generated (protobufjs) JSON to a flat list of services and types
var flattenSchema = function (parentPath) { return function (schema) {
    var nestedProps = R.prop('nested', schema);
    var getProps = R.pipe(Object.entries, R.chain(function (_a) {
        var _b = __read(_a, 2), name = _b[0], v = _b[1];
        var methods = v.methods, fields = v.fields, nested = v.nested;
        var namespace = parentPath;
        if (methods)
            return { namespace: namespace, type: 'service', name: name, methods: methods };
        else if (fields) {
            // Fix fields names the same way as protoc JS generator
            var fixName_1 = function (name) {
                var rule = fields[name].rule;
                var isList = rule === 'repeated';
                var listSuffix = isList ? 'List' : '';
                var genName = name.toLowerCase().replace(/_(\S)/g, function (_, x) { return x.toUpperCase(); });
                return "".concat(genName).concat(listSuffix);
            };
            var fixFieldName = function (acc, _a) {
                var _b;
                var _c = __read(_a, 2), k = _c[0], v = _c[1];
                var fieldName = fixName_1(k);
                return __assign(__assign({}, acc), (_b = {}, _b[fieldName] = v, _b));
            };
            var fieldsFixed = R.pipe(Object.entries, R.reduce(fixFieldName, {}));
            var nullables = R.pipe(R.propOr({}, 'oneofs'), Object.values, R.chain(R.prop('oneof')), R.map(fixName_1))(v);
            return { namespace: namespace, type: 'type', name: name, fields: fieldsFixed(fields), nullables: nullables };
        }
        else if (nested)
            return R.chain((0, exports.flattenSchema)(__spreadArray(__spreadArray([], __read(parentPath), false), [name], false)), [v]);
        else
            // Not important fields (scalapb options, ...)
            return;
    }), R.reject(R.isNil), R.reject(function (_a) {
        var namespace = _a.namespace;
        return R.contains(namespace, ignoredNamespaces);
    }));
    return getProps(nestedProps || {});
}; };
exports.flattenSchema = flattenSchema;
exports.then = R.curry(function (f, p) { return p.then(f); });
exports.thenAll = Promise.all.bind(Promise);
exports.mapAsync = R.curry(function (f, xs) { return __awaiter(void 0, void 0, void 0, function () { var _a, _b, _c, _d; return __generator(this, function (_e) {
    switch (_e.label) {
        case 0:
            _a = exports.thenAll;
            _c = (_b = R).map;
            _d = [f];
            return [4 /*yield*/, xs];
        case 1: return [2 /*return*/, _a.apply(void 0, [_c.apply(_b, _d.concat([_e.sent()]))])];
    }
}); }); });
exports.chainAsync = R.curry(function (f, xs) { return __awaiter(void 0, void 0, void 0, function () { var _a, _b, _c, _d; return __generator(this, function (_e) {
    switch (_e.label) {
        case 0:
            _b = (_a = R).flatten;
            _c = exports.mapAsync;
            _d = [f];
            return [4 /*yield*/, xs];
        case 1: return [4 /*yield*/, _c.apply(void 0, _d.concat([_e.sent()]))];
        case 2: return [2 /*return*/, _b.apply(_a, [_e.sent()])];
    }
}); }); });
exports.filterAsync = R.curry(function (pred, xs) { return __awaiter(void 0, void 0, void 0, function () {
    var predX, predXs, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                predX = function (x) { return __awaiter(void 0, void 0, void 0, function () {
                    var _a;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _a = {};
                                return [4 /*yield*/, pred(x)];
                            case 1: return [2 /*return*/, (_a.p = _b.sent(), _a.x = x, _a)];
                        }
                    });
                }); };
                _a = exports.mapAsync;
                _b = [predX];
                return [4 /*yield*/, xs];
            case 1: return [4 /*yield*/, _a.apply(void 0, _b.concat([_c.sent()]))];
            case 2:
                predXs = _c.sent();
                return [2 /*return*/, R.pipe(R.filter(R.prop('p')), (0, exports.mapAsync)(R.prop('x')))(predXs)];
        }
    });
}); });
var waitExit = function (proc, result, error) {
    return new Promise(function (resolve, reject) {
        proc.on('exit', function (code) {
            code === 0 ? resolve(result) : reject(error);
        });
    });
};
exports.waitExit = waitExit;
//# sourceMappingURL=lib.js.map